--- old/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
+++ new/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
@@ -1,10 +1,11 @@
 /*
- * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
  */
 
 /*
- * Copyright 2005-08 Adaptec, Inc.
- * Copyright (c) 2005-08 Adaptec Inc., Achim Leubner
+ * Copyright (c) 2010-12 PMC-Sierra, Inc.
+ * Copyright (c) 2005-10 Adaptec Inc., Achim Leubner
  * Copyright (c) 2000 Michael Smith
  * Copyright (c) 2001 Scott Long
  * Copyright (c) 2000 BSDi
@@ -31,6 +32,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  */
+#pragma ident	"@(#)aac.c	1.19	08/01/29 SMI"
+
 #include <sys/modctl.h>
 #include <sys/conf.h>
 #include <sys/cmn_err.h>
@@ -43,17 +46,33 @@
 #include <sys/ksynch.h>
 #include <sys/sunddi.h>
 #include <sys/byteorder.h>
+#include <sys/utsname.h>
 #include "aac_regs.h"
 #include "aac.h"
 
 /*
- * FMA header files
+ * FMA header files, macros
  */
 #include <sys/ddifm.h>
 #include <sys/fm/protocol.h>
 #include <sys/fm/util.h>
 #include <sys/fm/io/ddi.h>
+#ifndef DDI_FM_DEVICE
+#define DDI_FM_DEVICE			"device"
+#define DDI_FM_DEVICE_NO_RESPONSE	"no_response"
+#define ddi_fm_acc_err_clear(a, b)
+#endif
+#define aac_fm_service_impact(a, b) { \
+	if (aac_fm_valid) \
+		ddi_fm_service_impact(a, b); \
+	}
+#define aac_fm_acc_err_clear(a, b) { \
+	if (aac_fm_valid) \
+		ddi_fm_acc_err_clear(a, b); \
+	}
 
+char _depends_on[] = "misc/scsi";
+
 /*
  * For minor nodes created by the SCSA framework, minor numbers are
  * formed by left-shifting instance by INST_MINOR_SHIFT and OR in a
@@ -79,10 +98,6 @@
 				&(softs)->containers[(t)].dev : \
 				((t) < AAC_MAX_DEV(softs)) ? \
 				&(softs)->nondasds[AAC_PD(t)].dev : NULL)
-#define	AAC_DEVCFG_BEGIN(softs, tgt) \
-				aac_devcfg((softs), (tgt), 1)
-#define	AAC_DEVCFG_END(softs, tgt) \
-				aac_devcfg((softs), (tgt), 0)
 #define	PKT2AC(pkt)		((struct aac_cmd *)(pkt)->pkt_ha_private)
 #define	AAC_BUSYWAIT(cond, timeout /* in millisecond */) { \
 		if (!(cond)) { \
@@ -148,28 +163,28 @@
 #define	AAC_IS_Q_EMPTY(q)	((q)->q_head == NULL)
 #define	AAC_CMDQ(acp)		(!((acp)->flags & AAC_CMD_SYNC))
 
-#define	PCI_MEM_GET32(softs, off) \
-	ddi_get32((softs)->pci_mem_handle, \
-	    (void *)((softs)->pci_mem_base_vaddr + (off)))
-#define	PCI_MEM_PUT32(softs, off, val) \
-	ddi_put32((softs)->pci_mem_handle, \
-	    (void *)((softs)->pci_mem_base_vaddr + (off)), \
+#define	PCI_MEM_GET32(softs, i, off) \
+	ddi_get32((softs)->pci_mem_handle[i], \
+	    (uint32_t *)((softs)->pci_mem_base_vaddr[i] + (off)))
+#define	PCI_MEM_PUT32(softs, i, off, val) \
+	ddi_put32((softs)->pci_mem_handle[i], \
+	    (uint32_t *)((softs)->pci_mem_base_vaddr[i] + (off)), \
 	    (uint32_t)(val))
-#define	PCI_MEM_GET16(softs, off) \
-	ddi_get16((softs)->pci_mem_handle, \
-	(void *)((softs)->pci_mem_base_vaddr + (off)))
-#define	PCI_MEM_PUT16(softs, off, val) \
-	ddi_put16((softs)->pci_mem_handle, \
-	(void *)((softs)->pci_mem_base_vaddr + (off)), (uint16_t)(val))
-/* Write host data at valp to device mem[off] repeatedly count times */
-#define	PCI_MEM_REP_PUT8(softs, off, valp, count) \
-	ddi_rep_put8((softs)->pci_mem_handle, (uint8_t *)(valp), \
-	    (uint8_t *)((softs)->pci_mem_base_vaddr + (off)), \
+#define	PCI_MEM_GET16(softs, i, off) \
+	ddi_get16((softs)->pci_mem_handle[i], \
+	(uint16_t *)((softs)->pci_mem_base_vaddr[i] + (off)))
+#define	PCI_MEM_PUT16(softs, i, off, val) \
+	ddi_put16((softs)->pci_mem_handle[i], \
+	(uint16_t *)((softs)->pci_mem_base_vaddr[i] + (off)), (uint16_t)(val))
+/* Write host data at valp to device mem[i][off] repeatedly count times */
+#define	PCI_MEM_REP_PUT8(softs, i, off, valp, count) \
+	ddi_rep_put8((softs)->pci_mem_handle[i], (uint8_t *)(valp), \
+	    (uint8_t *)((softs)->pci_mem_base_vaddr[i] + (off)), \
 	    count, DDI_DEV_AUTOINCR)
-/* Read device data at mem[off] to host addr valp repeatedly count times */
-#define	PCI_MEM_REP_GET8(softs, off, valp, count) \
-	ddi_rep_get8((softs)->pci_mem_handle, (uint8_t *)(valp), \
-	    (uint8_t *)((softs)->pci_mem_base_vaddr + (off)), \
+/* Read device data at mem[i][off] to host addr valp repeatedly count times */
+#define	PCI_MEM_REP_GET8(softs, i, off, valp, count) \
+	ddi_rep_get8((softs)->pci_mem_handle[i], (uint8_t *)(valp), \
+	    (uint8_t *)((softs)->pci_mem_base_vaddr[i] + (off)), \
 	    count, DDI_DEV_AUTOINCR)
 #define	AAC_GET_FIELD8(acc, d, s, field) \
 	(d)->field = ddi_get8(acc, (uint8_t *)&(s)->field)
@@ -184,23 +199,18 @@
 	ddi_rep_get32((acc), (uint32_t *)&(d)->field, \
 	    (uint32_t *)&(s)->field, (r), DDI_DEV_AUTOINCR)
 
-#define	AAC_ENABLE_INTR(softs) { \
-		if (softs->flags & AAC_FLAGS_NEW_COMM) \
-			PCI_MEM_PUT32(softs, AAC_OIMR, ~AAC_DB_INTR_NEW); \
-		else \
-			PCI_MEM_PUT32(softs, AAC_OIMR, ~AAC_DB_INTR_BITS); \
-		softs->state |= AAC_STATE_INTR; \
-	}
+#define	AAC_OUTB_GET(softs)		PCI_MEM_GET32(softs, 0, AAC_OQUE)
+#define	AAC_OUTB_SET(softs, val)	PCI_MEM_PUT32(softs, 0, AAC_OQUE, val)
 
-#define	AAC_DISABLE_INTR(softs)	{ \
-		PCI_MEM_PUT32(softs, AAC_OIMR, ~0); \
-		softs->state &= ~AAC_STATE_INTR; \
-	}
-#define	AAC_STATUS_CLR(softs, mask)	PCI_MEM_PUT32(softs, AAC_ODBR, mask)
-#define	AAC_STATUS_GET(softs)		PCI_MEM_GET32(softs, AAC_ODBR)
-#define	AAC_NOTIFY(softs, val)		PCI_MEM_PUT32(softs, AAC_IDBR, val)
-#define	AAC_OUTB_GET(softs)		PCI_MEM_GET32(softs, AAC_OQUE)
-#define	AAC_OUTB_SET(softs, val)	PCI_MEM_PUT32(softs, AAC_OQUE, val)
+#define	AAC_SET_INTR(softs, enable)	\
+	((softs)->aac_if.aif_set_intr((softs), (enable)))
+#define	AAC_STATUS_CLR(softs, mask)	\
+	((softs)->aac_if.aif_status_clr((softs), (mask)))
+#define	AAC_STATUS_GET(softs)	\
+	((softs)->aac_if.aif_status_get(softs))
+#define	AAC_NOTIFY(softs, val)	\
+	((softs)->aac_if.aif_notify((softs), (val)))
+
 #define	AAC_FWSTATUS_GET(softs)	\
 	((softs)->aac_if.aif_get_fwstatus(softs))
 #define	AAC_MAILBOX_GET(softs, mb) \
@@ -208,8 +218,9 @@
 #define	AAC_MAILBOX_SET(softs, cmd, arg0, arg1, arg2, arg3) \
 	((softs)->aac_if.aif_set_mailbox((softs), (cmd), \
 	    (arg0), (arg1), (arg2), (arg3)))
+#define	AAC_SEND_COMMAND(softs, slotp) \
+	((softs)->aac_if.aif_send_command((softs), (slotp)))
 
-#define	AAC_MGT_SLOT_NUM	2
 #define	AAC_THROTTLE_DRAIN	-1
 
 #define	AAC_QUIESCE_TICK	1	/* 1 second */
@@ -220,22 +231,34 @@
 /* Poll time for aac_do_poll_io() */
 #define	AAC_POLL_TIME		60	/* 60 seconds */
 
-/* IOP reset */
-#define	AAC_IOP_RESET_SUCCEED		0	/* IOP reset succeed */
-#define	AAC_IOP_RESET_FAILED		-1	/* IOP reset failed */
-#define	AAC_IOP_RESET_ABNORMAL		-2	/* Reset operation abnormal */
-
 /*
  * Hardware access functions
  */
+static void aac_rx_set_intr(struct aac_softstate *, int);
+static void aac_rx_status_clr(struct aac_softstate *, int);
+static int aac_rx_status_get(struct aac_softstate *);
+static void aac_rx_notify(struct aac_softstate *, int);
 static int aac_rx_get_fwstatus(struct aac_softstate *);
 static int aac_rx_get_mailbox(struct aac_softstate *, int);
 static void aac_rx_set_mailbox(struct aac_softstate *, uint32_t, uint32_t,
     uint32_t, uint32_t, uint32_t);
+static int aac_rx_send_command(struct aac_softstate *, struct aac_slot *);
 static int aac_rkt_get_fwstatus(struct aac_softstate *);
 static int aac_rkt_get_mailbox(struct aac_softstate *, int);
 static void aac_rkt_set_mailbox(struct aac_softstate *, uint32_t, uint32_t,
     uint32_t, uint32_t, uint32_t);
+static void aac_src_set_intr(struct aac_softstate *, int);
+static void aac_src_status_clr(struct aac_softstate *, int);
+static int aac_src_status_get(struct aac_softstate *);
+static void aac_src_notify(struct aac_softstate *, int);
+static int aac_src_get_fwstatus(struct aac_softstate *);
+static int aac_src_get_mailbox(struct aac_softstate *, int);
+static void aac_src_set_mailbox(struct aac_softstate *, uint32_t, uint32_t,
+    uint32_t, uint32_t, uint32_t);
+static int aac_src_send_command(struct aac_softstate *, struct aac_slot *);
+static int aac_srcv_get_mailbox(struct aac_softstate *, int);
+static void aac_srcv_set_mailbox(struct aac_softstate *, uint32_t, uint32_t,
+    uint32_t, uint32_t, uint32_t);
 
 /*
  * SCSA function prototypes
@@ -243,17 +266,10 @@
 static int aac_attach(dev_info_t *, ddi_attach_cmd_t);
 static int aac_detach(dev_info_t *, ddi_detach_cmd_t);
 static int aac_reset(dev_info_t *, ddi_reset_cmd_t);
-static int aac_quiesce(dev_info_t *);
-static int aac_getinfo(dev_info_t *, ddi_info_cmd_t, void *, void **);
 
 /*
  * Interrupt handler functions
  */
-static int aac_query_intrs(struct aac_softstate *, int);
-static int aac_add_intrs(struct aac_softstate *);
-static void aac_remove_intrs(struct aac_softstate *);
-static int aac_enable_intrs(struct aac_softstate *);
-static int aac_disable_intrs(struct aac_softstate *);
 static uint_t aac_intr_old(caddr_t);
 static uint_t aac_intr_new(caddr_t);
 static uint_t aac_softintr(caddr_t);
@@ -275,7 +291,7 @@
  * Sync FIB operation functions
  */
 int aac_sync_mbcommand(struct aac_softstate *, uint32_t, uint32_t,
-    uint32_t, uint32_t, uint32_t, uint32_t *);
+    uint32_t, uint32_t, uint32_t, uint32_t *, uint32_t *);
 static int aac_sync_fib(struct aac_softstate *, uint16_t, uint16_t);
 
 /*
@@ -307,24 +323,24 @@
 /*
  * Internal functions
  */
-static void aac_cmd_fib_header(struct aac_softstate *, struct aac_cmd *,
-    uint16_t);
+static void aac_cmd_fib_header(struct aac_softstate *, struct aac_slot *,
+    uint16_t, uint16_t);
 static void aac_cmd_fib_rawio(struct aac_softstate *, struct aac_cmd *);
+static void aac_cmd_fib_rawio2(struct aac_softstate *, struct aac_cmd *);
+static uint_t aac_convert_sgraw2(struct aac_softstate *, struct aac_cmd *, 
+								 uint_t, uint_t, uint_t, uint16_t *);
 static void aac_cmd_fib_brw64(struct aac_softstate *, struct aac_cmd *);
 static void aac_cmd_fib_brw(struct aac_softstate *, struct aac_cmd *);
 static void aac_cmd_fib_sync(struct aac_softstate *, struct aac_cmd *);
+static void aac_cmd_aif_request(struct aac_softstate *, struct aac_cmd *);
+static void aac_aifreq_complete(struct aac_softstate *, struct aac_cmd *);
 static void aac_cmd_fib_scsi32(struct aac_softstate *, struct aac_cmd *);
 static void aac_cmd_fib_scsi64(struct aac_softstate *, struct aac_cmd *);
-static void aac_cmd_fib_startstop(struct aac_softstate *, struct aac_cmd *);
 static void aac_start_waiting_io(struct aac_softstate *);
 static void aac_drain_comp_q(struct aac_softstate *);
 int aac_do_io(struct aac_softstate *, struct aac_cmd *);
-static int aac_sync_fib_slot_bind(struct aac_softstate *, struct aac_cmd *);
-static void aac_sync_fib_slot_release(struct aac_softstate *, struct aac_cmd *);
-static void aac_start_io(struct aac_softstate *, struct aac_cmd *);
 static int aac_do_poll_io(struct aac_softstate *, struct aac_cmd *);
 static int aac_do_sync_io(struct aac_softstate *, struct aac_cmd *);
-static int aac_send_command(struct aac_softstate *, struct aac_slot *);
 static void aac_cmd_timeout(struct aac_softstate *, struct aac_cmd *);
 static int aac_dma_sync_ac(struct aac_cmd *);
 static int aac_shutdown(struct aac_softstate *);
@@ -334,20 +350,18 @@
 static void aac_unhold_bus(struct aac_softstate *, int);
 static void aac_set_throttle(struct aac_softstate *, struct aac_device *,
     int, int);
+static int aac_atoi(char **pptr);
+static void aac_config_pd(void *);
 
 /*
  * Adapter Initiated FIB handling function
  */
-static void aac_save_aif(struct aac_softstate *, ddi_acc_handle_t,
-    struct aac_fib *, int);
-static int aac_handle_aif(struct aac_softstate *, struct aac_aif_command *);
+static int aac_handle_aif(struct aac_softstate *, struct aac_fib *);
 
 /*
- * Event handling related functions
+ * Timeout handling thread function
  */
-static void aac_timer(void *);
-static void aac_event_thread(struct aac_softstate *);
-static void aac_event_disp(struct aac_softstate *, int);
+static void aac_daemon(void *);
 
 /*
  * IOCTL interface related functions
@@ -365,19 +379,13 @@
 static int aac_fm_error_cb(dev_info_t *, ddi_fm_error_t *, const void *);
 int aac_check_acc_handle(ddi_acc_handle_t);
 int aac_check_dma_handle(ddi_dma_handle_t);
-void aac_fm_ereport(struct aac_softstate *, char *);
+void aac_fm_ereport(struct aac_softstate *, char *, int);
 
-/*
- * Auto enumeration functions
- */
-static dev_info_t *aac_find_child(struct aac_softstate *, uint16_t, uint8_t);
 static int aac_tran_bus_config(dev_info_t *, uint_t, ddi_bus_config_op_t,
     void *, dev_info_t **);
-static int aac_handle_dr(struct aac_softstate *, int, int, int);
+static int aac_dr_event(struct aac_softstate *, int, int, int);
 
-extern pri_t minclsyspri;
-
-#ifdef DEBUG
+#ifdef AAC_DEBUG
 /*
  * UART	debug output support
  */
@@ -390,8 +398,6 @@
 #define	AAC_FW_DBG_BLED_OFFSET		0x08
 
 static int aac_get_fw_debug_buffer(struct aac_softstate *);
-static void aac_print_scmd(struct aac_softstate *, struct aac_cmd *);
-static void aac_print_aif(struct aac_softstate *, struct aac_aif_command *);
 
 static char aac_prt_buf[AAC_PRINT_BUFFER_SIZE];
 static char aac_fmt[] = " %s";
@@ -404,8 +410,8 @@
  */
 uint32_t aac_debug_flags =
 /*    AACDB_FLAGS_KERNEL_PRINT | */
-/*    AACDB_FLAGS_FW_PRINT |	*/
-/*    AACDB_FLAGS_MISC |	*/
+    AACDB_FLAGS_FW_PRINT |	
+    AACDB_FLAGS_MISC |	
 /*    AACDB_FLAGS_FUNC1 |	*/
 /*    AACDB_FLAGS_FUNC2 |	*/
 /*    AACDB_FLAGS_SCMD |	*/
@@ -413,16 +419,22 @@
 /*    AACDB_FLAGS_FIB |		*/
 /*    AACDB_FLAGS_IOCTL |	*/
 0;
-uint32_t aac_debug_fib_flags =
-/*    AACDB_FLAGS_FIB_RW |	*/
-/*    AACDB_FLAGS_FIB_IOCTL |	*/
-/*    AACDB_FLAGS_FIB_SRB |	*/
-/*    AACDB_FLAGS_FIB_SYNC |	*/
-/*    AACDB_FLAGS_FIB_HEADER |	*/
-/*    AACDB_FLAGS_FIB_TIMEOUT |	*/
-0;
+#endif /* AAC_DEBUG */
 
-#endif /* DEBUG */
+#ifdef AAC_DEBUG_ALL
+#ifndef GETG0COUNT
+#define GETG0COUNT(cdb)		(cdb)->g0_count0
+#endif
+#ifndef GETG1COUNT
+#define GETG1COUNT(cdb)		(((cdb)->g1_count1 << 8) + ((cdb)->g1_count0))
+#endif
+#ifndef GETG4COUNT
+#define GETG4COUNT(cdb)		(((cdb)->g4_count3 << 24) + \
+	((cdb)->g4_count2 << 16) + ((cdb)->g4_count1 << 8) + ((cdb)->g4_count0))
+#endif
+static void aac_print_scmd(struct aac_softstate *, struct aac_cmd *);
+static void aac_print_aif(struct aac_softstate *, struct aac_aif_command *);
+#endif /* AAC_DEBUG_ALL */
 
 static struct cb_ops aac_cb_ops = {
 	aac_open,	/* open */
@@ -448,7 +460,7 @@
 static struct dev_ops aac_dev_ops = {
 	DEVO_REV,
 	0,
-	aac_getinfo,
+	nodev,
 	nulldev,
 	nulldev,
 	aac_attach,
@@ -456,8 +468,7 @@
 	aac_reset,
 	&aac_cb_ops,
 	NULL,
-	NULL,
-	aac_quiesce,
+	NULL
 };
 
 static struct modldrv aac_modldrv = {
@@ -611,9 +622,14 @@
  * Hardware access functions for i960 based cards
  */
 static struct aac_interface aac_rx_interface = {
+	aac_rx_set_intr,
+	aac_rx_status_clr,
+	aac_rx_status_get,
+	aac_rx_notify,
 	aac_rx_get_fwstatus,
 	aac_rx_get_mailbox,
-	aac_rx_set_mailbox
+	aac_rx_set_mailbox,
+	aac_rx_send_command
 };
 
 /*
@@ -620,13 +636,46 @@
  * Hardware access functions for Rocket based cards
  */
 static struct aac_interface aac_rkt_interface = {
+	aac_rx_set_intr,
+	aac_rx_status_clr,
+	aac_rx_status_get,
+	aac_rx_notify,
 	aac_rkt_get_fwstatus,
 	aac_rkt_get_mailbox,
-	aac_rkt_set_mailbox
+	aac_rkt_set_mailbox,
+	aac_rx_send_command
 };
 
+/*
+ * Hardware access functions for PMC SRC based cards
+ */
+static struct aac_interface aac_src_interface = {
+	aac_src_set_intr,
+	aac_src_status_clr,
+	aac_src_status_get,
+	aac_src_notify,
+	aac_src_get_fwstatus,
+	aac_src_get_mailbox,
+	aac_src_set_mailbox,
+	aac_src_send_command
+};
+
+/*
+ * Hardware access functions for PMC SRCv based cards
+ */
+static struct aac_interface aac_srcv_interface = {
+	aac_src_set_intr,
+	aac_src_status_clr,
+	aac_src_status_get,
+	aac_src_notify,
+	aac_src_get_fwstatus,
+	aac_srcv_get_mailbox,
+	aac_srcv_set_mailbox,
+	aac_src_send_command
+};
+
 ddi_device_acc_attr_t aac_acc_attr = {
-	DDI_DEVICE_ATTR_V1,
+	DDI_DEVICE_ATTR_V0,
 	DDI_STRUCTURE_LE_ACC,
 	DDI_STRICTORDER_ACC,
 	DDI_DEFAULT_ACC
@@ -664,8 +713,17 @@
 	0		/* DMA transfer flags */
 };
 
+struct aac_drinfo {
+	struct aac_softstate *softs;
+	int tgt;
+	int lun;
+	int event;
+};
+
 static int aac_tick = AAC_DEFAULT_TICK;	/* tick for the internal timer */
 static uint32_t aac_timebase = 0;	/* internal timer in seconds */
+static uint32_t aac_sync_time = 0;	/* next time to sync. with firmware */
+static int aac_fm_valid = 0;		/* FMA support */
 
 /*
  * Warlock directives
@@ -687,6 +745,7 @@
     aac_sg_table aac_srb))
 _NOTE(SCHEME_PROTECTS_DATA("unique to sync fib and cdb", scsi_inquiry))
 _NOTE(SCHEME_PROTECTS_DATA("stable data", scsi_device scsi_address))
+_NOTE(SCHEME_PROTECTS_DATA("unique to dr event", aac_drinfo))
 _NOTE(SCHEME_PROTECTS_DATA("unique to scsi_transport", buf))
 
 int
@@ -694,7 +753,7 @@
 {
 	int rval = 0;
 
-#ifdef DEBUG
+#ifdef AAC_DEBUG
 	mutex_init(&aac_prt_mutex, NULL, MUTEX_DRIVER, NULL);
 #endif
 	DBCALLED(NULL, 1);
@@ -717,7 +776,7 @@
 
 error:
 	AACDB_PRINT(NULL, CE_WARN, "Mod init error!");
-#ifdef DEBUG
+#ifdef AAC_DEBUG
 	mutex_destroy(&aac_prt_mutex);
 #endif
 	return (rval);
@@ -746,7 +805,7 @@
 
 	scsi_hba_fini(&aac_modlinkage);
 	ddi_soft_state_fini((void *)&aac_softstatep);
-#ifdef DEBUG
+#ifdef AAC_DEBUG
 	mutex_destroy(&aac_prt_mutex);
 #endif
 	return (0);
@@ -759,7 +818,7 @@
 static int
 aac_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 {
-	int instance, i;
+	int instance, i, major, minor;
 	struct aac_softstate *softs = NULL;
 	int attach_state = 0;
 	char *data;
@@ -789,17 +848,11 @@
 	softs->devinfo_p = dip;
 	softs->buf_dma_attr = softs->addr_dma_attr = aac_dma_attr;
 	softs->addr_dma_attr.dma_attr_granular = 1;
-	softs->acc_attr = aac_acc_attr;
-	softs->reg_attr = aac_acc_attr;
 	softs->card = AAC_UNKNOWN_CARD;
-#ifdef DEBUG
+#ifdef AAC_DEBUG
 	softs->debug_flags = aac_debug_flags;
-	softs->debug_fib_flags = aac_debug_fib_flags;
 #endif
 
-	/* Initialize FMA */
-	aac_fm_init(softs);
-
 	/* Check the card type */
 	if (aac_check_card_type(softs) == AACERR) {
 		AACDB_PRINT(softs, CE_WARN, "Card not supported");
@@ -808,85 +861,159 @@
 	/* We have found the right card and everything is OK */
 	attach_state |= AAC_ATTACH_CARD_DETECTED;
 
+	/*
+	 * Initialize FMA
+	 */
+#ifdef FORCE_FM_SUPPORT
+	aac_fm_valid = 1;
+#else
+	aac_fm_valid = 0;
+	/* check OS version */
+	data = (char *)utsname.release;
+	major = aac_atoi(&data);
+	if (*data == '.') {
+		data++;
+		minor = aac_atoi(&data);
+		/* enable FMA support in Solaris 11 first */
+		if (major >= 5 && minor >= 11)
+			aac_fm_valid = 1;
+	}
+#endif
+	aac_fm_init(softs);
+
 	/* Map PCI mem space */
 	if (ddi_regs_map_setup(dip, 1,
-	    (caddr_t *)&softs->pci_mem_base_vaddr, 0,
-	    softs->map_size_min, &softs->reg_attr,
-	    &softs->pci_mem_handle) != DDI_SUCCESS)
+	    (caddr_t *)&softs->pci_mem_base_vaddr[0], 0,
+	    softs->map_size_min, &aac_acc_attr,
+	    &softs->pci_mem_handle[0]) != DDI_SUCCESS)
 		goto error;
+	if (softs->hwif == AAC_HWIF_SRC) {
+		/*
+		 * Map whole space because map_size_min is not enough
+		 * for NEMER/ARK family with APRE
+		 */
+		if (ddi_regs_map_setup(dip, 2,
+		    (caddr_t *)&softs->pci_mem_base_vaddr[1], 0,
+		    softs->hwif == AAC_HWIF_SRC ? AAC_MAP_SIZE_MIN_SRC_BAR1 : AAC_MAP_SIZE_MIN_SRCV_BAR1, 
+			&aac_acc_attr,
+		    &softs->pci_mem_handle[1]) != DDI_SUCCESS) {
+			ddi_regs_map_free(&softs->pci_mem_handle[0]);
+			goto error;
+		}
+	} else {
+		/* Setup BAR1 related values */
+		softs->pci_mem_handle[1] = softs->pci_mem_handle[0];
+		softs->pci_mem_base_vaddr[1] = softs->pci_mem_base_vaddr[0];
+	}
 
 	softs->map_size = softs->map_size_min;
 	attach_state |= AAC_ATTACH_PCI_MEM_MAPPED;
 
-	AAC_DISABLE_INTR(softs);
+	AAC_SET_INTR(softs, 0);
 
-	/* Init mutexes and condvars */
-	mutex_init(&softs->io_lock, NULL, MUTEX_DRIVER,
-	    DDI_INTR_PRI(softs->intr_pri));
-	mutex_init(&softs->q_comp_mutex, NULL, MUTEX_DRIVER,
-	    DDI_INTR_PRI(softs->intr_pri));
-	mutex_init(&softs->time_mutex, NULL, MUTEX_DRIVER,
-	    DDI_INTR_PRI(softs->intr_pri));
-	mutex_init(&softs->ev_lock, NULL, MUTEX_DRIVER,
-	    DDI_INTR_PRI(softs->intr_pri));
-	mutex_init(&softs->aifq_mutex, NULL,
-	    MUTEX_DRIVER, DDI_INTR_PRI(softs->intr_pri));
+	if (ddi_intr_hilevel(dip, 0)) {
+		AACDB_PRINT(softs, CE_WARN,
+		    "High level interrupt is not supported!");
+		goto error;
+	}
+
+	/* Init mutexes */
+	if (ddi_get_iblock_cookie(dip, 0, &softs->iblock_cookie) !=
+	    DDI_SUCCESS) {
+		AACDB_PRINT(softs, CE_WARN,
+		    "Can not get interrupt block cookie!");
+		goto error;
+	}
+	mutex_init(&softs->q_comp_mutex, NULL,
+	    MUTEX_DRIVER, (void *)softs->iblock_cookie);
 	cv_init(&softs->event, NULL, CV_DRIVER, NULL);
-	cv_init(&softs->sync_fib_cv, NULL, CV_DRIVER, NULL);
+	mutex_init(&softs->aifq_mutex, NULL,
+	    MUTEX_DRIVER, (void *)softs->iblock_cookie);
+	cv_init(&softs->aifv, NULL, CV_DRIVER, NULL);
 	cv_init(&softs->drain_cv, NULL, CV_DRIVER, NULL);
-	cv_init(&softs->event_wait_cv, NULL, CV_DRIVER, NULL);
-	cv_init(&softs->event_disp_cv, NULL, CV_DRIVER, NULL);
-	cv_init(&softs->aifq_cv, NULL, CV_DRIVER, NULL);
+	mutex_init(&softs->io_lock, NULL, MUTEX_DRIVER,
+	    (void *)softs->iblock_cookie);
 	attach_state |= AAC_ATTACH_KMUTEX_INITED;
 
-	/* Init the cmd queues */
-	for (i = 0; i < AAC_CMDQ_NUM; i++)
-		aac_cmd_initq(&softs->q_wait[i]);
-	aac_cmd_initq(&softs->q_busy);
-	aac_cmd_initq(&softs->q_comp);
-
 	/* Check for legacy device naming support */
-	softs->legacy = 1; /* default to use legacy name */
 	if ((ddi_prop_lookup_string(DDI_DEV_T_ANY, dip, 0,
 	    "legacy-name-enable", &data) == DDI_SUCCESS)) {
-		if (strcmp(data, "no") == 0) {
-			AACDB_PRINT(softs, CE_NOTE, "legacy-name disabled");
-			softs->legacy = 0;
+		if (strcmp(data, "yes") == 0) {
+			AACDB_PRINT(softs, CE_NOTE, "aac-legacy-name enabled");
+			softs->legacy = 1;
 		}
 		ddi_prop_free(data);
 	}
-
-	/*
-	 * Everything has been set up till now,
-	 * we will do some common attach.
-	 */
-	mutex_enter(&softs->io_lock);
-	if (aac_common_attach(softs) == AACERR) {
-		mutex_exit(&softs->io_lock);
-		goto error;
+	/* Check for sync. transfer mode */
+	if ((ddi_prop_lookup_string(DDI_DEV_T_ANY, dip, 0,
+	    "enforce-sync-mode", &data) == DDI_SUCCESS)) {
+		if (strcmp(data, "yes") == 0) {
+			AACDB_PRINT(softs, CE_NOTE, "enforce-sync-mode set");
+			softs->sync_mode = 1;
+		}
+		ddi_prop_free(data);
 	}
-	mutex_exit(&softs->io_lock);
-	attach_state |= AAC_ATTACH_COMM_SPACE_SETUP;
-
-	/* Check for buf breakup support */
+	/* Convert S/G table (NEW_COMM_TYPE2) */
 	if ((ddi_prop_lookup_string(DDI_DEV_T_ANY, dip, 0,
-	    "breakup-enable", &data) == DDI_SUCCESS)) {
+	    "disable-sgl-conversion", &data) == DDI_SUCCESS)) {
 		if (strcmp(data, "yes") == 0) {
-			AACDB_PRINT(softs, CE_NOTE, "buf breakup enabled");
-			softs->flags |= AAC_FLAGS_BRKUP;
+			AACDB_PRINT(softs, CE_NOTE, "disable-sgl-conversion set");
+			softs->no_sgl_conv = 1;
 		}
 		ddi_prop_free(data);
 	}
-	softs->dma_max = softs->buf_dma_attr.dma_attr_maxxfer;
-	if (softs->flags & AAC_FLAGS_BRKUP) {
-		softs->dma_max = ddi_prop_get_int(DDI_DEV_T_ANY, dip,
-		    DDI_PROP_DONTPASS, "dma-max", softs->dma_max);
+
+	/* Create a taskq for dealing with dr events, suspend taskq */
+	if ((softs->taskq = ddi_taskq_create(dip, "aac_dr_taskq", 1,
+	    TASKQ_DEFAULTPRI, 0)) == NULL) {
+		AACDB_PRINT(softs, CE_WARN, "ddi_taskq_create failed");
+		goto error;
 	}
+	ddi_taskq_suspend(softs->taskq);
 
+	/*
+	 * Everything has been set up till now (especially taskq and hba_tran
+	 * for auto-enumeration), we will do some common attach.
+	 */
+	if (aac_common_attach(softs) == AACERR)
+		goto error;
+	attach_state |= AAC_ATTACH_COMM_SPACE_SETUP;
+
+	/* Init the cmd queues */
+	for (i = 0; i < AAC_CMDQ_NUM; i++)
+		aac_cmd_initq(&softs->q_wait[i]);
+	aac_cmd_initq(&softs->q_busy);
+	aac_cmd_initq(&softs->q_comp);
+
+	/* allocate and fill the scsi_hba_tran_t structure */
 	if (aac_hba_setup(softs) != AACOK)
 		goto error;
 	attach_state |= AAC_ATTACH_SCSI_TRAN_SETUP;
 
+	/* scsi_hba_tran is now initialized, resume taskq */
+	ddi_taskq_resume(softs->taskq);
+
+	/* Connect interrupt handlers */
+	if (ddi_add_softintr(dip, DDI_SOFTINT_LOW, &softs->softint_id,
+	    NULL, NULL, aac_softintr, (caddr_t)softs) != DDI_SUCCESS) {
+		AACDB_PRINT(softs, CE_WARN,
+		    "Can not setup soft interrupt handler!");
+		goto error;
+	}
+	attach_state |= AAC_ATTACH_SOFT_INTR_SETUP;
+
+	/* Solaris 11 Express: avoid tran_start calls before aac_unhold_bus() */
+	mutex_enter(&softs->io_lock);
+
+	if (ddi_add_intr(dip, 0, &softs->iblock_cookie,
+	    (ddi_idevice_cookie_t *)0,
+	    (softs->flags & AAC_FLAGS_NEW_COMM) ?
+	    aac_intr_new : aac_intr_old, (caddr_t)softs) != DDI_SUCCESS) {
+		AACDB_PRINT(softs, CE_WARN, "Can not setup interrupt handler!");
+		goto error;
+	}
+	attach_state |= AAC_ATTACH_HARD_INTR_SETUP;
+
 	/* Create devctl/scsi nodes for cfgadm */
 	if (ddi_create_minor_node(dip, "devctl", S_IFCHR,
 	    INST2DEVCTL(instance), DDI_NT_SCSI_NEXUS, 0) != DDI_SUCCESS) {
@@ -909,30 +1036,23 @@
 		goto error;
 	}
 
-	/* Common attach is OK, so we are attached! */
-	softs->state |= AAC_STATE_RUN;
-
-	/* Create event thread */
-	softs->fibctx_p = &softs->aifctx;
-	if ((softs->event_thread = thread_create(NULL, 0, aac_event_thread,
-	    softs, 0, &p0, TS_RUN, minclsyspri)) == NULL) {
-		AACDB_PRINT(softs, CE_WARN, "aif thread create failed");
-		softs->state &= ~AAC_STATE_RUN;
-		goto error;
-	}
-
 	aac_unhold_bus(softs, AAC_IOCMD_SYNC | AAC_IOCMD_ASYNC);
+	softs->state = AAC_STATE_RUN;
+	mutex_exit(&softs->io_lock);
 
 	/* Create a thread for command timeout */
-	softs->timeout_id = timeout(aac_timer, (void *)softs,
-	    (aac_tick * drv_usectohz(1000000)));
+	softs->timeout_id = timeout(aac_daemon, (void *)softs,
+	    (60 * drv_usectohz(1000000)));
 
 	/* Common attach is OK, so we are attached! */
+	AAC_SET_INTR(softs, 1);
 	ddi_report_dev(dip);
 	AACDB_PRINT(softs, CE_NOTE, "aac attached ok");
 	return (DDI_SUCCESS);
 
 error:
+	if (softs && softs->taskq)
+		ddi_taskq_destroy(softs->taskq);
 	if (attach_state & AAC_ATTACH_CREATE_SCSI)
 		ddi_remove_minor_node(dip, "scsi");
 	if (attach_state & AAC_ATTACH_CREATE_DEVCTL)
@@ -943,21 +1063,23 @@
 		(void) scsi_hba_detach(dip);
 		scsi_hba_tran_free(AAC_DIP2TRAN(dip));
 	}
+	if (attach_state & AAC_ATTACH_HARD_INTR_SETUP)
+		ddi_remove_intr(dip, 0, softs->iblock_cookie);
+	if (attach_state & AAC_ATTACH_SOFT_INTR_SETUP)
+		ddi_remove_softintr(softs->softint_id);
 	if (attach_state & AAC_ATTACH_KMUTEX_INITED) {
-		mutex_destroy(&softs->io_lock);
 		mutex_destroy(&softs->q_comp_mutex);
-		mutex_destroy(&softs->time_mutex);
-		mutex_destroy(&softs->ev_lock);
-		mutex_destroy(&softs->aifq_mutex);
 		cv_destroy(&softs->event);
-		cv_destroy(&softs->sync_fib_cv);
+		mutex_destroy(&softs->aifq_mutex);
+		cv_destroy(&softs->aifv);
 		cv_destroy(&softs->drain_cv);
-		cv_destroy(&softs->event_wait_cv);
-		cv_destroy(&softs->event_disp_cv);
-		cv_destroy(&softs->aifq_cv);
+		mutex_destroy(&softs->io_lock);
 	}
-	if (attach_state & AAC_ATTACH_PCI_MEM_MAPPED)
-		ddi_regs_map_free(&softs->pci_mem_handle);
+	if (attach_state & AAC_ATTACH_PCI_MEM_MAPPED) {
+		ddi_regs_map_free(&softs->pci_mem_handle[0]);
+		if (softs->hwif == AAC_HWIF_SRC)
+			ddi_regs_map_free(&softs->pci_mem_handle[1]);
+	}
 	aac_fm_fini(softs);
 	if (attach_state & AAC_ATTACH_CARD_DETECTED)
 		softs->card = AACERR;
@@ -984,52 +1106,39 @@
 	}
 
 	mutex_enter(&softs->io_lock);
-	AAC_DISABLE_INTR(softs);
+	AAC_SET_INTR(softs, 0);
 	softs->state = AAC_STATE_STOPPED;
 
+	mutex_exit(&softs->io_lock);
+	(void) untimeout(softs->timeout_id);
+	mutex_enter(&softs->io_lock);
+	softs->timeout_id = 0;
+
+	ddi_taskq_destroy(softs->taskq);
+
 	ddi_remove_minor_node(dip, "aac");
 	ddi_remove_minor_node(dip, "scsi");
 	ddi_remove_minor_node(dip, "devctl");
+
 	mutex_exit(&softs->io_lock);
+	ddi_remove_intr(dip, 0, softs->iblock_cookie);
+	ddi_remove_softintr(softs->softint_id);
 
 	aac_common_detach(softs);
 
-	mutex_enter(&softs->io_lock);
 	(void) scsi_hba_detach(dip);
 	scsi_hba_tran_free(tran);
-	mutex_exit(&softs->io_lock);
 
-	/* Stop timer */
-	mutex_enter(&softs->time_mutex);
-	if (softs->timeout_id) {
-		timeout_id_t tid = softs->timeout_id;
-		softs->timeout_id = 0;
-
-		mutex_exit(&softs->time_mutex);
-		(void) untimeout(tid);
-		mutex_enter(&softs->time_mutex);
-	}
-	mutex_exit(&softs->time_mutex);
-
-	/* Destroy event thread */
-	mutex_enter(&softs->ev_lock);
-	cv_signal(&softs->event_disp_cv);
-	cv_wait(&softs->event_wait_cv, &softs->ev_lock);
-	mutex_exit(&softs->ev_lock);
-
-	cv_destroy(&softs->aifq_cv);
-	cv_destroy(&softs->event_disp_cv);
-	cv_destroy(&softs->event_wait_cv);
-	cv_destroy(&softs->drain_cv);
-	cv_destroy(&softs->sync_fib_cv);
+	mutex_destroy(&softs->q_comp_mutex);
 	cv_destroy(&softs->event);
 	mutex_destroy(&softs->aifq_mutex);
-	mutex_destroy(&softs->ev_lock);
-	mutex_destroy(&softs->time_mutex);
-	mutex_destroy(&softs->q_comp_mutex);
+	cv_destroy(&softs->aifv);
+	cv_destroy(&softs->drain_cv);
 	mutex_destroy(&softs->io_lock);
 
-	ddi_regs_map_free(&softs->pci_mem_handle);
+	ddi_regs_map_free(&softs->pci_mem_handle[0]);
+	if (softs->hwif == AAC_HWIF_SRC)
+		ddi_regs_map_free(&softs->pci_mem_handle[1]);
 	aac_fm_fini(softs);
 	softs->hwif = AAC_HWIF_UNKNOWN;
 	softs->card = AAC_UNKNOWN_CARD;
@@ -1047,7 +1156,6 @@
 	DBCALLED(softs, 1);
 
 	mutex_enter(&softs->io_lock);
-	AAC_DISABLE_INTR(softs);
 	(void) aac_shutdown(softs);
 	mutex_exit(&softs->io_lock);
 
@@ -1055,47 +1163,6 @@
 }
 
 /*
- * quiesce(9E) entry point.
- *
- * This function is called when the system is single-threaded at high
- * PIL with preemption disabled. Therefore, this function must not be
- * blocked.
- *
- * This function returns DDI_SUCCESS on success, or DDI_FAILURE on failure.
- * DDI_FAILURE indicates an error condition and should almost never happen.
- */
-static int
-aac_quiesce(dev_info_t *dip)
-{
-	struct aac_softstate *softs = AAC_DIP2SOFTS(dip);
-
-	if (softs == NULL)
-		return (DDI_FAILURE);
-
-	_NOTE(ASSUMING_PROTECTED(softs->state))
-	AAC_DISABLE_INTR(softs);
-
-	return (DDI_SUCCESS);
-}
-
-/* ARGSUSED */
-static int
-aac_getinfo(dev_info_t *self, ddi_info_cmd_t infocmd, void *arg,
-    void **result)
-{
-	int error = DDI_SUCCESS;
-
-	switch (infocmd) {
-	case DDI_INFO_DEVT2INSTANCE:
-		*result = (void *)(intptr_t)(MINOR2INST(getminor((dev_t)arg)));
-		break;
-	default:
-		error = DDI_FAILURE;
-	}
-	return (error);
-}
-
-/*
  * Bring the controller down to a dormant state and detach all child devices.
  * This function is called before detach or system shutdown.
  * Note: we can assume that the q_wait on the controller is empty, as we
@@ -1104,15 +1171,11 @@
 static int
 aac_shutdown(struct aac_softstate *softs)
 {
-	ddi_acc_handle_t acc;
-	struct aac_close_command *cc;
+	ddi_acc_handle_t acc = softs->sync_slot->fib_acc_handle;
+	struct aac_close_command *cc = (struct aac_close_command *) \
+	    &softs->sync_slot->fibp->data[0];
 	int rval;
 
-	(void) aac_sync_fib_slot_bind(softs, &softs->sync_ac);
-	acc = softs->sync_ac.slotp->fib_acc_handle;
-
-	cc = (struct aac_close_command *)&softs->sync_ac.slotp->fibp->data[0];
-
 	ddi_put32(acc, &cc->Command, VM_CloseAll);
 	ddi_put32(acc, &cc->ContainerId, 0xfffffffful);
 
@@ -1119,7 +1182,6 @@
 	/* Flush all caches, set FW to write through mode */
 	rval = aac_sync_fib(softs, ContainerCommand,
 	    AAC_FIB_SIZEOF(struct aac_close_command));
-	aac_sync_fib_slot_release(softs, &softs->sync_ac);
 
 	AACDB_PRINT(softs, CE_NOTE,
 	    "shutting down aac %s", (rval == AACOK) ? "ok" : "fail");
